darcs-2.12.5: a distributed, interactive, smart revision control system

Safe Haskell | None
Language | Haskell2010

Darcs.UI.Options.All

Description

All the concrete options.

Notes:

- The term "option" refers to a flag or combination of flags that together form a part of a command's configuration. Ideally, options should be orthogonal to each other, so we can freely combine them.
- A primitive (indivisible) option has an associate value type.
- An option named "xyzActions" represents a set of flags that act as mutually exclusive sub-commands. They typically have a dedicated value type named "XyzAction".
- This module is probably best imported qualified. This is in contrast to the current practice of using subtly differing names to avoid name clashes for closely related items. For instance, the data constructors for an option's value type and the corresponding data constructors in `DarcsFlag` may coincide. This is also why we import Darcs.UI.Flags qualified here.
- When the new options system is finally in place, no code other than the one for constructing options should directly refer to `DarcsFlag` constructors.

Synopsis

- type DarcsOption = OptSpec DarcsOptDescr Flag
- data RootAction
  - = RootHelp
  - | Version
  - | ExactVersion
  - | ListCommands
- rootActions :: PrimDarcsOption (Maybe RootAction)
- data StdCmdAction
  - = Help
  - | ListOptions
  - | Disable
- stdCmdActions :: PrimDarcsOption (Maybe StdCmdAction)
- debug :: PrimDarcsOption Bool
- data Verbosity
  - = Quiet
  - | NormalVerbosity
  - | Verbose
- verbosity :: PrimDarcsOption Verbosity
- timings :: PrimDarcsOption Bool
- anyVerbosity :: DarcsOption a (Bool -> Bool -> Verbosity -> Bool -> a)
- preHook :: DarcsOption a (Maybe String -> Bool -> a)
- postHook :: DarcsOption a (Maybe String -> Bool -> a)
- hooks :: DarcsOption a (Maybe String -> Bool -> Maybe String -> Bool -> a)
- data UseCache
  - = YesUseCache
  - | NoUseCache
- useCache :: PrimDarcsOption UseCache
- data XmlOutput
  - = NoXml
  - | YesXml
- xmloutput :: PrimDarcsOption XmlOutput
- data DryRun
  - = YesDryRun
  - | NoDryRun
- dryRun :: PrimDarcsOption DryRun
- dryRunXml :: DarcsOption a (DryRun -> XmlOutput -> a)
- interactive :: PrimDarcsOption (Maybe Bool)
- pipe :: PrimDarcsOption Bool
- data WantGuiPause
  - = YesWantGuiPause
  - | NoWantGuiPause
- pauseForGui :: PrimDarcsOption WantGuiPause
- askdeps :: PrimDarcsOption Bool
- module Darcs.UI.Options.Matching
- data SelectDeps
  - = NoDeps
  - | AutoDeps
  - | PromptDeps
- selectDeps :: PrimDarcsOption SelectDeps
- changesReverse :: PrimDarcsOption Bool
- matchMaxcount :: PrimDarcsOption (Maybe Int)
- data WorkRepo
  - = WorkRepoDir String
  - | WorkRepoPossibleURL String
  - | WorkRepoCurrentDir
- workRepo :: PrimDarcsOption WorkRepo
- workingRepoDir :: PrimDarcsOption (Maybe String)
- data RemoteRepos = RemoteRepos [String]
- remoteRepos :: PrimDarcsOption RemoteRepos
- possiblyRemoteRepo :: PrimDarcsOption (Maybe String)
- reponame :: PrimDarcsOption (Maybe String)
- notInRemote :: PrimDarcsOption [Maybe String]
- notInRemoteFlagName :: String
- data RepoCombinator
  - = Intersection
  - | Union
  - | Complement
- repoCombinator :: PrimDarcsOption RepoCombinator
- allowUnrelatedRepos :: PrimDarcsOption Bool
- justThisRepo :: PrimDarcsOption Bool
- data WithWorkingDir
  - = WithWorkingDir
  - | NoWorkingDir
- useWorkingDir :: PrimDarcsOption WithWorkingDir
- data SetDefault
  - = YesSetDefault Bool
  - | NoSetDefault Bool
- setDefault :: PrimDarcsOption (Maybe Bool)
- patchname :: PrimDarcsOption (Maybe String)
- author :: PrimDarcsOption (Maybe String)
- data AskLongComment
  - = NoEditLongComment
  - | YesEditLongComment
  - | PromptLongComment
- askLongComment :: PrimDarcsOption (Maybe AskLongComment)
- keepDate :: PrimDarcsOption Bool
- data Logfile = Logfile {
  - _logfile :: Maybe AbsolutePath
  - _rmlogfile :: Bool
  }
- logfile :: PrimDarcsOption Logfile
- data LookFor = LookFor {
  - adds :: LookForAdds
  - replaces :: LookForReplaces
  - moves :: LookForMoves
  }
- data LookForAdds
  - = YesLookForAdds
  - | NoLookForAdds
- data LookForMoves
  - = YesLookForMoves
  - | NoLookForMoves
- data LookForReplaces
  - = YesLookForReplaces
  - | NoLookForReplaces
- lookfor :: PrimDarcsOption LookFor
- data UseIndex
  - = UseIndex
  - | IgnoreIndex
- data ScanKnown
  - = ScanKnown
  - | ScanAll
  - | ScanBoring
- diffing :: PrimDarcsOption (UseIndex, ScanKnown, DiffAlgorithm)
- data IncludeBoring
  - = YesIncludeBoring
  - | NoIncludeBoring
- includeBoring :: PrimDarcsOption IncludeBoring
- allowProblematicFilenames :: DarcsOption a (Bool -> Bool -> a)
- allowCaseDifferingFilenames :: PrimDarcsOption Bool
- allowWindowsReservedFilenames :: PrimDarcsOption Bool
- onlyToFiles :: PrimDarcsOption Bool
- useIndex :: PrimDarcsOption UseIndex
- recursive :: PrimDarcsOption Bool
- data DiffAlgorithm
  - = PatienceDiff
  - | MyersDiff
- diffAlgorithm :: PrimDarcsOption DiffAlgorithm
- data WithContext
  - = NoContext
  - | YesContext
- withContext :: PrimDarcsOption WithContext
- unidiff :: PrimDarcsOption Bool
- data ExternalDiff = ExternalDiff {
  - _diffCmd :: Maybe String
  - _diffOpts :: [String]
  }
- extDiff :: PrimDarcsOption ExternalDiff
- data TestChanges
  - = NoTestChanges
  - | YesTestChanges LeaveTestDir
- testChanges :: PrimDarcsOption TestChanges
- data RunTest
  - = YesRunTest
  - | NoRunTest
- test :: PrimDarcsOption RunTest
- data LeaveTestDir
  - = YesLeaveTestDir
  - | NoLeaveTestDir
- leaveTestDir :: PrimDarcsOption LeaveTestDir
- data HeaderFields = HeaderFields {
  - _to, _cc :: [String]
  - _from, _subject, _inReplyTo :: Maybe String
  }
- headerFields :: PrimDarcsOption HeaderFields
- sendToContext :: PrimDarcsOption (Maybe AbsolutePath)
- sendmail :: PrimDarcsOption (Bool, Maybe String)
- sendmailCmd :: PrimDarcsOption (Maybe String)
- charset :: PrimDarcsOption (Maybe String)
- editDescription :: PrimDarcsOption Bool
- ccApply :: PrimDarcsOption (Maybe String)
- reply :: PrimDarcsOption (Maybe String)
- happyForwarding :: PrimDarcsOption Bool
- applyAs :: PrimDarcsOption (Maybe String)
- data Sign
  - = NoSign
  - | Sign
  - | SignAs String
  - | SignSSL String
- sign :: PrimDarcsOption Sign
- data Verify
  - = NoVerify
  - | VerifyKeyring AbsolutePath
  - | VerifySSL AbsolutePath
- verify :: PrimDarcsOption Verify
- data AllowConflicts
  - = NoAllowConflicts
  - | YesAllowConflicts
  - | YesAllowConflictsAndMark
- conflicts :: AllowConflicts -> PrimDarcsOption (Maybe AllowConflicts)
- data ExternalMerge
  - = YesExternalMerge String
  - | NoExternalMerge
- useExternalMerge :: PrimDarcsOption ExternalMerge
- data Compression
  - = NoCompression
  - | GzipCompression
- compress :: PrimDarcsOption Compression
- usePacks :: PrimDarcsOption Bool
- data WithPatchIndex
  - = YesPatchIndex
  - | NoPatchIndex
- patchIndex :: PrimDarcsOption WithPatchIndex
- patchIndexYes :: PrimDarcsOption WithPatchIndex
- data Reorder
  - = NoReorder
  - | Reorder
- reorder :: PrimDarcsOption Reorder
- minimize :: PrimDarcsOption Bool
- storeInMemory :: PrimDarcsOption Bool
- data Output
  - = Output AbsolutePathOrStd
  - | OutputAutoName AbsolutePath
- output :: PrimDarcsOption (Maybe Output)
- data Summary
  - = NoSummary
  - | YesSummary
- summary :: PrimDarcsOption (Maybe Summary)
- data RemoteDarcs
  - = RemoteDarcs String
  - | DefaultRemoteDarcs
- data NetworkOptions = NetworkOptions {
  - noHttpPipelining :: Bool
  - remoteDarcs :: RemoteDarcs
  }
- network :: PrimDarcsOption NetworkOptions
- data UMask
  - = YesUMask String
  - | NoUMask
- umask :: PrimDarcsOption UMask
- data SetScriptsExecutable
  - = YesSetScriptsExecutable
  - | NoSetScriptsExecutable
- setScriptsExecutable :: PrimDarcsOption SetScriptsExecutable
- restrictPaths :: PrimDarcsOption Bool
- amendUnrecord :: PrimDarcsOption Bool
- selectAuthor :: PrimDarcsOption Bool
- humanReadable :: PrimDarcsOption Bool
- machineReadable :: PrimDarcsOption Bool
- data CloneKind
  - = LazyClone
  - | NormalClone
  - | CompleteClone
- partial :: PrimDarcsOption CloneKind
- distname :: PrimDarcsOption (Maybe String)
- distzip :: PrimDarcsOption Bool
- marks :: DarcsOption a (Maybe String -> Maybe String -> a)
- readMarks :: PrimDarcsOption (Maybe String)
- writeMarks :: PrimDarcsOption (Maybe String)
- data PatchFormat
  - = PatchFormat1
  - | PatchFormat2
- patchFormat :: PrimDarcsOption PatchFormat
- hashed :: PrimDarcsOption ()
- data ChangesFormat
  - = HumanReadable
  - | MachineReadable
  - | GenContext
  - | GenXml
  - | NumberPatches
  - | CountPatches
- changesFormat :: PrimDarcsOption (Maybe ChangesFormat)
- tokens :: PrimDarcsOption (Maybe String)
- forceReplace :: PrimDarcsOption Bool
- data TestStrategy
  - = Once
  - | Linear
  - | Backoff
  - | Bisect
- testStrategy :: PrimDarcsOption TestStrategy
- files :: PrimDarcsOption Bool
- directories :: PrimDarcsOption Bool
- pending :: PrimDarcsOption Bool
- nullFlag :: PrimDarcsOption Bool
- data GzcrcsAction
  - = GzcrcsCheck
  - | GzcrcsRepair
- gzcrcsActions :: PrimDarcsOption (Maybe GzcrcsAction)
- siblings :: PrimDarcsOption [AbsolutePath]
- reorderPatches :: PrimDarcsOption Bool
- optimizePatchIndex :: PrimDarcsOption (Maybe WithPatchIndex)

# Documentation

type DarcsOption = OptSpec DarcsOptDescr Flag #

`DarcsOption` instantiates the first two type parameters of `OptSpec` to what we need in darcs. The first parameter is instantiated to The flag type is instantiate to `Flag`.

data RootAction #

Options for darcs iself that act like sub-commands.

Constructors

RootHelp |
Version |
ExactVersion |
ListCommands |

Instances

Eq RootAction # |
Methods (==) :: RootAction -> RootAction -> Bool # (/=) :: RootAction -> RootAction -> Bool #
Show RootAction # |
Methods showsPrec :: Int -> RootAction -> ShowS # show :: RootAction -> String # showList :: [RootAction] -> ShowS #

rootActions :: PrimDarcsOption (Maybe RootAction) #

data StdCmdAction #

Constructors

Help |
ListOptions |
Disable |

Instances

Eq StdCmdAction # |
Methods (==) :: StdCmdAction -> StdCmdAction -> Bool # (/=) :: StdCmdAction -> StdCmdAction -> Bool #
Show StdCmdAction # |
Methods showsPrec :: Int -> StdCmdAction -> ShowS # show :: StdCmdAction -> String # showList :: [StdCmdAction] -> ShowS #

stdCmdActions :: PrimDarcsOption (Maybe StdCmdAction) #

debug :: PrimDarcsOption Bool #

data Verbosity #

Constructors

Quiet |
NormalVerbosity |
Verbose |

Instances

Eq Verbosity # |
Methods (==) :: Verbosity -> Verbosity -> Bool # (/=) :: Verbosity -> Verbosity -> Bool #
Show Verbosity # |
Methods showsPrec :: Int -> Verbosity -> ShowS # show :: Verbosity -> String # showList :: [Verbosity] -> ShowS #

verbosity :: PrimDarcsOption Verbosity #

timings :: PrimDarcsOption Bool #

anyVerbosity :: DarcsOption a (Bool -> Bool -> Verbosity -> Bool -> a) #

preHook :: DarcsOption a (Maybe String -> Bool -> a) #

postHook :: DarcsOption a (Maybe String -> Bool -> a) #

hooks :: DarcsOption a (Maybe String -> Bool -> Maybe String -> Bool -> a) #

data UseCache #

Constructors

YesUseCache |
NoUseCache |

Instances

Eq UseCache # |
Methods (==) :: UseCache -> UseCache -> Bool # (/=) :: UseCache -> UseCache -> Bool #
Show UseCache # |
Methods showsPrec :: Int -> UseCache -> ShowS # show :: UseCache -> String # showList :: [UseCache] -> ShowS #

useCache :: PrimDarcsOption UseCache #

data XmlOutput #

Constructors

NoXml |
YesXml |

Instances

Eq XmlOutput # |
Methods (==) :: XmlOutput -> XmlOutput -> Bool # (/=) :: XmlOutput -> XmlOutput -> Bool #
Show XmlOutput # |
Methods showsPrec :: Int -> XmlOutput -> ShowS # show :: XmlOutput -> String # showList :: [XmlOutput] -> ShowS #

xmloutput :: PrimDarcsOption XmlOutput #

data DryRun #

Constructors

YesDryRun |
NoDryRun |

Instances

Eq DryRun # |
Methods (==) :: DryRun -> DryRun -> Bool # (/=) :: DryRun -> DryRun -> Bool #
Show DryRun # |
Methods showsPrec :: Int -> DryRun -> ShowS # show :: DryRun -> String # showList :: [DryRun] -> ShowS #

dryRun :: PrimDarcsOption DryRun #

NOTE: I'd rather work to have no uses of dryRunNoxml, so that any time --dry-run is a possibility, automated users can examine the results more easily with --xml.

See also issue2397.

dryRunXml :: DarcsOption a (DryRun -> XmlOutput -> a) #

interactive :: PrimDarcsOption (Maybe Bool) #

pipe :: PrimDarcsOption Bool #

data WantGuiPause #

Constructors

YesWantGuiPause |
NoWantGuiPause |

Instances

Eq WantGuiPause # |
Methods (==) :: WantGuiPause -> WantGuiPause -> Bool # (/=) :: WantGuiPause -> WantGuiPause -> Bool #
Show WantGuiPause # |
Methods showsPrec :: Int -> WantGuiPause -> ShowS # show :: WantGuiPause -> String # showList :: [WantGuiPause] -> ShowS #

pauseForGui :: PrimDarcsOption WantGuiPause #

askdeps :: PrimDarcsOption Bool #

module Darcs.UI.Options.Matching

data SelectDeps #

Constructors

NoDeps |
AutoDeps |
PromptDeps |

Instances

Eq SelectDeps # |
Methods (==) :: SelectDeps -> SelectDeps -> Bool # (/=) :: SelectDeps -> SelectDeps -> Bool #
Show SelectDeps # |
Methods showsPrec :: Int -> SelectDeps -> ShowS # show :: SelectDeps -> String # showList :: [SelectDeps] -> ShowS #

selectDeps :: PrimDarcsOption SelectDeps #

changesReverse :: PrimDarcsOption Bool #

matchMaxcount :: PrimDarcsOption (Maybe Int) #

TODO: Returning `-1` if the argument cannot be parsed as an integer is not something I expected to find in a Haskell program. Instead, the flag should take either a plain `String` argument (leaving it to a later stage to parse the `String` to an `Int`), or else a ``Maybe` `Int``, taking the possibility of a failed parse into account.

data WorkRepo #

Constructors

WorkRepoDir String |
WorkRepoPossibleURL String |
WorkRepoCurrentDir |

Instances

Eq WorkRepo # |
Methods (==) :: WorkRepo -> WorkRepo -> Bool # (/=) :: WorkRepo -> WorkRepo -> Bool #
Show WorkRepo # |
Methods showsPrec :: Int -> WorkRepo -> ShowS # show :: WorkRepo -> String # showList :: [WorkRepo] -> ShowS #

workRepo :: PrimDarcsOption WorkRepo #

workingRepoDir :: PrimDarcsOption (Maybe String) #

data RemoteRepos #

Constructors

RemoteRepos [String] |

Instances

Eq RemoteRepos # |
Methods (==) :: RemoteRepos -> RemoteRepos -> Bool # (/=) :: RemoteRepos -> RemoteRepos -> Bool #
Show RemoteRepos # |
Methods showsPrec :: Int -> RemoteRepos -> ShowS # show :: RemoteRepos -> String # showList :: [RemoteRepos] -> ShowS #

remoteRepos :: PrimDarcsOption RemoteRepos #

possiblyRemoteRepo :: PrimDarcsOption (Maybe String) #

reponame :: PrimDarcsOption (Maybe String) #

`--repodir` is there for compatibility, should be removed eventually

IMHO the whole option can disappear; it overlaps with using an extra (non-option) argument, which is how e.g. `darcs get` is usually invoked.

notInRemote :: PrimDarcsOption [Maybe String] #

notInRemoteFlagName :: String #

data RepoCombinator #

Constructors

Intersection |
Union |
Complement |

Instances

Eq RepoCombinator # |
Methods (==) :: RepoCombinator -> RepoCombinator -> Bool # (/=) :: RepoCombinator -> RepoCombinator -> Bool #
Show RepoCombinator # |
Methods showsPrec :: Int -> RepoCombinator -> ShowS # show :: RepoCombinator -> String # showList :: [RepoCombinator] -> ShowS #

repoCombinator :: PrimDarcsOption RepoCombinator #

allowUnrelatedRepos :: PrimDarcsOption Bool #

justThisRepo :: PrimDarcsOption Bool #

data WithWorkingDir #

Constructors

WithWorkingDir |
NoWorkingDir |

Instances

Eq WithWorkingDir # |
Methods (==) :: WithWorkingDir -> WithWorkingDir -> Bool # (/=) :: WithWorkingDir -> WithWorkingDir -> Bool #
Show WithWorkingDir # |
Methods showsPrec :: Int -> WithWorkingDir -> ShowS # show :: WithWorkingDir -> String # showList :: [WithWorkingDir] -> ShowS #

useWorkingDir :: PrimDarcsOption WithWorkingDir #

convert, clone, init

data SetDefault #

Constructors

YesSetDefault Bool |
NoSetDefault Bool |

Instances

Eq SetDefault # |
Methods (==) :: SetDefault -> SetDefault -> Bool # (/=) :: SetDefault -> SetDefault -> Bool #
Show SetDefault # |
Methods showsPrec :: Int -> SetDefault -> ShowS # show :: SetDefault -> String # showList :: [SetDefault] -> ShowS #

setDefault :: PrimDarcsOption (Maybe Bool) #

patchname :: PrimDarcsOption (Maybe String) #

author :: PrimDarcsOption (Maybe String) #

data AskLongComment #

Constructors

NoEditLongComment |
YesEditLongComment |
PromptLongComment |

Instances

Eq AskLongComment # |
Methods (==) :: AskLongComment -> AskLongComment -> Bool # (/=) :: AskLongComment -> AskLongComment -> Bool #
Show AskLongComment # |
Methods showsPrec :: Int -> AskLongComment -> ShowS # show :: AskLongComment -> String # showList :: [AskLongComment] -> ShowS #

askLongComment :: PrimDarcsOption (Maybe AskLongComment) #

keepDate :: PrimDarcsOption Bool #

data Logfile #

Constructors

Logfile |
Fields _logfile :: Maybe AbsolutePath _rmlogfile :: Bool

logfile :: PrimDarcsOption Logfile #

data LookFor #

Constructors

LookFor |
Fields adds :: LookForAdds replaces :: LookForReplaces moves :: LookForMoves

data LookForAdds #

Constructors

YesLookForAdds |
NoLookForAdds |

Instances

Eq LookForAdds # |
Methods (==) :: LookForAdds -> LookForAdds -> Bool # (/=) :: LookForAdds -> LookForAdds -> Bool #
Show LookForAdds # |
Methods showsPrec :: Int -> LookForAdds -> ShowS # show :: LookForAdds -> String # showList :: [LookForAdds] -> ShowS #

data LookForMoves #

Constructors

YesLookForMoves |
NoLookForMoves |

Instances

Eq LookForMoves # |
Methods (==) :: LookForMoves -> LookForMoves -> Bool # (/=) :: LookForMoves -> LookForMoves -> Bool #
Show LookForMoves # |
Methods showsPrec :: Int -> LookForMoves -> ShowS # show :: LookForMoves -> String # showList :: [LookForMoves] -> ShowS #

data LookForReplaces #

Constructors

YesLookForReplaces |
NoLookForReplaces |

Instances

Eq LookForReplaces # |
Methods (==) :: LookForReplaces -> LookForReplaces -> Bool # (/=) :: LookForReplaces -> LookForReplaces -> Bool #
Show LookForReplaces # |
Methods showsPrec :: Int -> LookForReplaces -> ShowS # show :: LookForReplaces -> String # showList :: [LookForReplaces] -> ShowS #

lookfor :: PrimDarcsOption LookFor #

data UseIndex #

Constructors

UseIndex |
IgnoreIndex |

Instances

Eq UseIndex # |
Methods (==) :: UseIndex -> UseIndex -> Bool # (/=) :: UseIndex -> UseIndex -> Bool #
Show UseIndex # |
Methods showsPrec :: Int -> UseIndex -> ShowS # show :: UseIndex -> String # showList :: [UseIndex] -> ShowS #

data ScanKnown #

Constructors

ScanKnown | Just files already known to darcs
ScanAll | All files, i.e. look for new ones
ScanBoring | All files, even boring ones

Instances

Eq ScanKnown # |
Methods (==) :: ScanKnown -> ScanKnown -> Bool # (/=) :: ScanKnown -> ScanKnown -> Bool #
Show ScanKnown # |
Methods showsPrec :: Int -> ScanKnown -> ShowS # show :: ScanKnown -> String # showList :: [ScanKnown] -> ShowS #

diffing :: PrimDarcsOption (UseIndex, ScanKnown, DiffAlgorithm) #

data IncludeBoring #

Constructors

YesIncludeBoring |
NoIncludeBoring |

Instances

Eq IncludeBoring # |
Methods (==) :: IncludeBoring -> IncludeBoring -> Bool # (/=) :: IncludeBoring -> IncludeBoring -> Bool #
Show IncludeBoring # |
Methods showsPrec :: Int -> IncludeBoring -> ShowS # show :: IncludeBoring -> String # showList :: [IncludeBoring] -> ShowS #

includeBoring :: PrimDarcsOption IncludeBoring #

allowProblematicFilenames :: DarcsOption a (Bool -> Bool -> a) #

allowCaseDifferingFilenames :: PrimDarcsOption Bool #

allowWindowsReservedFilenames :: PrimDarcsOption Bool #

onlyToFiles :: PrimDarcsOption Bool #

TODO: see issue2395

useIndex :: PrimDarcsOption UseIndex #

recursive :: PrimDarcsOption Bool #

data DiffAlgorithm #

Constructors

PatienceDiff |
MyersDiff |

Instances

Eq DiffAlgorithm # |
Methods (==) :: DiffAlgorithm -> DiffAlgorithm -> Bool # (/=) :: DiffAlgorithm -> DiffAlgorithm -> Bool #
Show DiffAlgorithm # |
Methods showsPrec :: Int -> DiffAlgorithm -> ShowS # show :: DiffAlgorithm -> String # showList :: [DiffAlgorithm] -> ShowS #

diffAlgorithm :: PrimDarcsOption DiffAlgorithm #

data WithContext #

Constructors

NoContext |
YesContext |

Instances

Eq WithContext # |
Methods (==) :: WithContext -> WithContext -> Bool # (/=) :: WithContext -> WithContext -> Bool #
Show WithContext # |
Methods showsPrec :: Int -> WithContext -> ShowS # show :: WithContext -> String # showList :: [WithContext] -> ShowS #

withContext :: PrimDarcsOption WithContext #

unidiff :: PrimDarcsOption Bool #

data ExternalDiff #

Constructors

ExternalDiff |
Fields _diffCmd :: Maybe String _diffOpts :: [String]

Instances

Eq ExternalDiff # |
Methods (==) :: ExternalDiff -> ExternalDiff -> Bool # (/=) :: ExternalDiff -> ExternalDiff -> Bool #
Show ExternalDiff # |
Methods showsPrec :: Int -> ExternalDiff -> ShowS # show :: ExternalDiff -> String # showList :: [ExternalDiff] -> ShowS #

extDiff :: PrimDarcsOption ExternalDiff #

data TestChanges #

Constructors

NoTestChanges |
YesTestChanges LeaveTestDir |

Instances

Eq TestChanges # |
Methods (==) :: TestChanges -> TestChanges -> Bool # (/=) :: TestChanges -> TestChanges -> Bool #

testChanges :: PrimDarcsOption TestChanges #

data RunTest #

Constructors

YesRunTest |
NoRunTest |

Instances

Eq RunTest # |
Methods (==) :: RunTest -> RunTest -> Bool # (/=) :: RunTest -> RunTest -> Bool #
Show RunTest # |
Methods showsPrec :: Int -> RunTest -> ShowS # show :: RunTest -> String # showList :: [RunTest] -> ShowS #

test :: PrimDarcsOption RunTest #

data LeaveTestDir #

Constructors

YesLeaveTestDir |
NoLeaveTestDir |

Instances

Eq LeaveTestDir # |
Methods (==) :: LeaveTestDir -> LeaveTestDir -> Bool # (/=) :: LeaveTestDir -> LeaveTestDir -> Bool #
Show LeaveTestDir # |
Methods showsPrec :: Int -> LeaveTestDir -> ShowS # show :: LeaveTestDir -> String # showList :: [LeaveTestDir] -> ShowS #

leaveTestDir :: PrimDarcsOption LeaveTestDir #

data HeaderFields #

Constructors

HeaderFields |
Fields _to, _cc :: [String] _from, _subject, _inReplyTo :: Maybe String

headerFields :: PrimDarcsOption HeaderFields #

sendToContext :: PrimDarcsOption (Maybe AbsolutePath) #

sendmail :: PrimDarcsOption (Bool, Maybe String) #

sendmailCmd :: PrimDarcsOption (Maybe String) #

charset :: PrimDarcsOption (Maybe String) #

editDescription :: PrimDarcsOption Bool #

ccApply :: PrimDarcsOption (Maybe String) #

reply :: PrimDarcsOption (Maybe String) #

happyForwarding :: PrimDarcsOption Bool #

applyAs :: PrimDarcsOption (Maybe String) #

data Sign #

Constructors

NoSign |
Sign |
SignAs String |
SignSSL String |

Instances

Eq Sign # |
Methods (==) :: Sign -> Sign -> Bool # (/=) :: Sign -> Sign -> Bool #
Show Sign # |
Methods showsPrec :: Int -> Sign -> ShowS # show :: Sign -> String # showList :: [Sign] -> ShowS #

sign :: PrimDarcsOption Sign #

data Verify #

Constructors

NoVerify |
VerifyKeyring AbsolutePath |
VerifySSL AbsolutePath |

Instances

Eq Verify # |
Methods (==) :: Verify -> Verify -> Bool # (/=) :: Verify -> Verify -> Bool #
Show Verify # |
Methods showsPrec :: Int -> Verify -> ShowS # show :: Verify -> String # showList :: [Verify] -> ShowS #

verify :: PrimDarcsOption Verify #

data AllowConflicts #

Constructors

NoAllowConflicts |
YesAllowConflicts |
YesAllowConflictsAndMark |

Instances

Eq AllowConflicts # |
Methods (==) :: AllowConflicts -> AllowConflicts -> Bool # (/=) :: AllowConflicts -> AllowConflicts -> Bool #
Show AllowConflicts # |
Methods showsPrec :: Int -> AllowConflicts -> ShowS # show :: AllowConflicts -> String # showList :: [AllowConflicts] -> ShowS #

conflicts :: AllowConflicts -> PrimDarcsOption (Maybe AllowConflicts) #

data ExternalMerge #

Constructors

YesExternalMerge String |
NoExternalMerge |

Instances

Eq ExternalMerge # |
Methods (==) :: ExternalMerge -> ExternalMerge -> Bool # (/=) :: ExternalMerge -> ExternalMerge -> Bool #
Show ExternalMerge # |
Methods showsPrec :: Int -> ExternalMerge -> ShowS # show :: ExternalMerge -> String # showList :: [ExternalMerge] -> ShowS #

useExternalMerge :: PrimDarcsOption ExternalMerge #

data Compression #

Constructors

NoCompression |
GzipCompression |

Instances

Eq Compression # |
Methods (==) :: Compression -> Compression -> Bool # (/=) :: Compression -> Compression -> Bool #
Show Compression # |
Methods showsPrec :: Int -> Compression -> ShowS # show :: Compression -> String # showList :: [Compression] -> ShowS #

compress :: PrimDarcsOption Compression #

usePacks :: PrimDarcsOption Bool #

data WithPatchIndex #

Constructors

YesPatchIndex |
NoPatchIndex |

Instances

Eq WithPatchIndex # |
Methods (==) :: WithPatchIndex -> WithPatchIndex -> Bool # (/=) :: WithPatchIndex -> WithPatchIndex -> Bool #
Show WithPatchIndex # |
Methods showsPrec :: Int -> WithPatchIndex -> ShowS # show :: WithPatchIndex -> String # showList :: [WithPatchIndex] -> ShowS #

patchIndex :: PrimDarcsOption WithPatchIndex #

patchIndexYes :: PrimDarcsOption WithPatchIndex #

data Reorder #

Constructors

NoReorder |
Reorder |

Instances

Eq Reorder # |
Methods (==) :: Reorder -> Reorder -> Bool # (/=) :: Reorder -> Reorder -> Bool #

reorder :: PrimDarcsOption Reorder #

minimize :: PrimDarcsOption Bool #

storeInMemory :: PrimDarcsOption Bool #

data Output #

Constructors

Output AbsolutePathOrStd |
OutputAutoName AbsolutePath |

Instances

Eq Output # |
Methods (==) :: Output -> Output -> Bool # (/=) :: Output -> Output -> Bool #
Show Output # |
Methods showsPrec :: Int -> Output -> ShowS # show :: Output -> String # showList :: [Output] -> ShowS #

output :: PrimDarcsOption (Maybe Output) #

data Summary #

Constructors

NoSummary |
YesSummary |

Instances

Eq Summary # |
Methods (==) :: Summary -> Summary -> Bool # (/=) :: Summary -> Summary -> Bool #
Show Summary # |
Methods showsPrec :: Int -> Summary -> ShowS # show :: Summary -> String # showList :: [Summary] -> ShowS #

summary :: PrimDarcsOption (Maybe Summary) #

data RemoteDarcs #

Constructors

RemoteDarcs String |
DefaultRemoteDarcs |

Instances

Eq RemoteDarcs # |
Methods (==) :: RemoteDarcs -> RemoteDarcs -> Bool # (/=) :: RemoteDarcs -> RemoteDarcs -> Bool #
Show RemoteDarcs # |
Methods showsPrec :: Int -> RemoteDarcs -> ShowS # show :: RemoteDarcs -> String # showList :: [RemoteDarcs] -> ShowS #

data NetworkOptions #

TODO: reconsider this grouping of options

Constructors

NetworkOptions |
Fields noHttpPipelining :: Bool remoteDarcs :: RemoteDarcs

network :: PrimDarcsOption NetworkOptions #

data UMask #

Constructors

YesUMask String |
NoUMask |

Instances

Eq UMask # |
Methods (==) :: UMask -> UMask -> Bool # (/=) :: UMask -> UMask -> Bool #
Show UMask # |
Methods showsPrec :: Int -> UMask -> ShowS # show :: UMask -> String # showList :: [UMask] -> ShowS #

umask :: PrimDarcsOption UMask #

data SetScriptsExecutable #

Constructors

YesSetScriptsExecutable |
NoSetScriptsExecutable |

Instances

Eq SetScriptsExecutable # |
Methods (==) :: SetScriptsExecutable -> SetScriptsExecutable -> Bool # (/=) :: SetScriptsExecutable -> SetScriptsExecutable -> Bool #
Show SetScriptsExecutable # |
Methods showsPrec :: Int -> SetScriptsExecutable -> ShowS # show :: SetScriptsExecutable -> String # showList :: [SetScriptsExecutable] -> ShowS #

setScriptsExecutable :: PrimDarcsOption SetScriptsExecutable #

restrictPaths :: PrimDarcsOption Bool #

amendUnrecord :: PrimDarcsOption Bool #

selectAuthor :: PrimDarcsOption Bool #

humanReadable :: PrimDarcsOption Bool #

TODO: These should be mutually exclusive, but are they? The code is almost inscrutable.

machineReadable :: PrimDarcsOption Bool #

See above.

data CloneKind #

Constructors

LazyClone | Just copy pristine and inventories
NormalClone | First do a lazy clone then copy everything
CompleteClone | Same as Normal but omit telling user they can interrumpt

Instances

Eq CloneKind # |
Methods (==) :: CloneKind -> CloneKind -> Bool # (/=) :: CloneKind -> CloneKind -> Bool #
Show CloneKind # |
Methods showsPrec :: Int -> CloneKind -> ShowS # show :: CloneKind -> String # showList :: [CloneKind] -> ShowS #

partial :: PrimDarcsOption CloneKind #

distname :: PrimDarcsOption (Maybe String) #

distzip :: PrimDarcsOption Bool #

marks :: DarcsOption a (Maybe String -> Maybe String -> a) #

readMarks :: PrimDarcsOption (Maybe String) #

writeMarks :: PrimDarcsOption (Maybe String) #

data PatchFormat #

Constructors

PatchFormat1 |
PatchFormat2 |

Instances

Eq PatchFormat # |
Methods (==) :: PatchFormat -> PatchFormat -> Bool # (/=) :: PatchFormat -> PatchFormat -> Bool #
Show PatchFormat # |
Methods showsPrec :: Int -> PatchFormat -> ShowS # show :: PatchFormat -> String # showList :: [PatchFormat] -> ShowS #

patchFormat :: PrimDarcsOption PatchFormat #

hashed :: PrimDarcsOption () #

Deprecated flag, still present to output an error message.

data ChangesFormat #

Constructors

HumanReadable |
MachineReadable |
GenContext |
GenXml |
NumberPatches |
CountPatches |

Instances

Eq ChangesFormat # |
Methods (==) :: ChangesFormat -> ChangesFormat -> Bool # (/=) :: ChangesFormat -> ChangesFormat -> Bool #
Show ChangesFormat # |
Methods showsPrec :: Int -> ChangesFormat -> ShowS # show :: ChangesFormat -> String # showList :: [ChangesFormat] -> ShowS #

changesFormat :: PrimDarcsOption (Maybe ChangesFormat) #

tokens :: PrimDarcsOption (Maybe String) #

forceReplace :: PrimDarcsOption Bool #

data TestStrategy #

Constructors

Once |
Linear |
Backoff |
Bisect |

Instances

Eq TestStrategy # |
Methods (==) :: TestStrategy -> TestStrategy -> Bool # (/=) :: TestStrategy -> TestStrategy -> Bool #
Show TestStrategy # |
Methods showsPrec :: Int -> TestStrategy -> ShowS # show :: TestStrategy -> String # showList :: [TestStrategy] -> ShowS #

testStrategy :: PrimDarcsOption TestStrategy #

files :: PrimDarcsOption Bool #

directories :: PrimDarcsOption Bool #

pending :: PrimDarcsOption Bool #

nullFlag :: PrimDarcsOption Bool #

data GzcrcsAction #

Constructors

GzcrcsCheck |
GzcrcsRepair |

Instances

Eq GzcrcsAction # |
Methods (==) :: GzcrcsAction -> GzcrcsAction -> Bool # (/=) :: GzcrcsAction -> GzcrcsAction -> Bool #
Show GzcrcsAction # |
Methods showsPrec :: Int -> GzcrcsAction -> ShowS # show :: GzcrcsAction -> String # showList :: [GzcrcsAction] -> ShowS #

gzcrcsActions :: PrimDarcsOption (Maybe GzcrcsAction) #

siblings :: PrimDarcsOption [AbsolutePath] #

reorderPatches :: PrimDarcsOption Bool #

optimizePatchIndex :: PrimDarcsOption (Maybe WithPatchIndex) #